#!/usr/bin/env python

from PyQt4 import QtCore, QtGui
import random
import sys

class SignalGenerator(QtCore.QObject):

    def __init__(self, level, state, parent=None):

        QtCore.QObject.__init__(self)
        self._left = None
        self._right = None
        self._state = state
        self._level = level

        if parent:
            self.connect(parent,
                         QtCore.SIGNAL("some_signal"),
                         self.handle_signal)
        
        if level == 0:
            return
        self._left = SignalGenerator(level-1, 0, self)
        self._right = SignalGenerator(level-1, 1, self)

    def handle_signal(self, value):
        b = (value & (1 << self._level)) >> self._level
        if self._level == 0:
            if b == self._state:
                print "Trigger ", value, self
        else:
            if b == self._state:
                self.emit(QtCore.SIGNAL("some_signal"), value)

generate_many = True
depth = 13

class MyWidget(QtGui.QWidget):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)

        quit = QtGui.QPushButton("Generate")
        quit.setFont(QtGui.QFont("Times", 18, QtGui.QFont.Bold))

        lcd = QtGui.QLCDNumber(2)

        slider = QtGui.QSlider(QtCore.Qt.Horizontal)
        slider.setRange(0, 99)
        slider.setValue(0)

        self.connect(quit, QtCore.SIGNAL("clicked()"),
                     self.trigger_signals)
        self.connect(slider, QtCore.SIGNAL("valueChanged(int)"),
                     lcd, QtCore.SLOT("display(int)"))

        layout = QtGui.QVBoxLayout()
        layout.addWidget(quit)
        layout.addWidget(lcd)
        layout.addWidget(slider)
        self.setLayout(layout)
        if generate_many:
            self._generator = SignalGenerator(depth, 0)

    def trigger_signals(self):
        if generate_many:
            self._generator.emit(QtCore.SIGNAL("some_signal"),
                                 random.randint(1, 1 << depth))


app = QtGui.QApplication(sys.argv)
widget = MyWidget()
widget.show()
sys.exit(app.exec_())
